#pragma once
#include <map>
#include <string>
#include <utility>
#include "../nsmsgs/CommonService.h"

//*************************************************************************

typedef std::map<HNsmConnection, HNsmConnection> ConnectionMap;
typedef std::map<std::string, HNsmConnection> AccountMap;

//*************************************************************************

class CAccountMap
{
private:
	ConnectionMap m_conMap;
	AccountMap m_accMap;

public:
	CAccountMap(void)
	{
	}
	~CAccountMap(void)
	{
	}

	HNsmConnection GetAccountID(HNsmConnection hConnection)
	{
		ConnectionMap::iterator i;
		i = m_conMap.find(hConnection);
		return ( i != m_conMap.end() ) ? i->second: NULL;
	}
	bool RegistConnection(HNsmConnection hConnection)
	{
		_ASSERT( m_conMap.find(hConnection) == m_conMap.end() );
		char acc[256];
		AccountMap::iterator i;
		bool bFirst = false;

		NSM_SERVICE.GetUserAccount(hConnection, acc, sizeof(acc));
		i = m_accMap.find(acc);
		if( i == m_accMap.end() ){
			bFirst = true;
			i = m_accMap.insert(std::make_pair(acc, hConnection)).first;
		}
		m_conMap[hConnection] = i->second;
		return bFirst;
	}
    void UnregistConnection(HNsmConnection hConnection)
	{
		_ASSERT( m_conMap.find(hConnection) != m_conMap.end() );
		m_conMap.erase(hConnection);
	}
};
