#include "StdAfx.h"
#include <algorithm>
#include ".\comloginfo.h"
#include "FilterSettingDlg.h"
#include "NsmPlugin.h"

void CComLogInfo::LoadSettings()
{
	m_bAutoScroll	= COMLOG_SETTING.LoadAutoScrollState();
	m_bAutoStop		= COMLOG_SETTING.LoadAutoStopState();
	m_bEnableFilter = COMLOG_SETTING.LoadEnableFilter();
	m_logmax		= COMLOG_SETTING.LoadMaxLog();
	COMLOG_SETTING.LoadFilters(m_bFiltering);
	COMLOG_SETTING.LoadCustomFilter(m_custom);
	SetFilter();
}

void CComLogInfo::SetFilter()
{
	m_filter.ClearFilter();
	if( m_bFiltering[FILTER_CONNECT] ){
		// T[oƂ̐ڑ
		m_filter.AddFilters("VER CVR USR XFR INF OUT");
	}
	if( m_bFiltering[FILTER_PNG] ){
		// T[oƂ̐ڑmF
		m_filter.AddFilters("PNG QNG CHL QRY");
	}
	if( m_bFiltering[FILTER_MEMBERLIST] ){
		// oXg
		m_filter.AddFilters("SYN GTC BLP LSG LST PRP BPR ADD REM ADG RMG REG");
	}
	if( m_bFiltering[FILTER_MEMBERSTATE] ){
		// oԕύX
		m_filter.AddFilters("CHG REA NLN FLN ILN");
	}
	if( m_bFiltering[FILTER_SESSION] ){
		// ZbV
		m_filter.AddFilters("CAL RNG ANS IRO JOI BYE FIL TFR CCL");
	}
	if( m_bFiltering[FILTER_MSG] ){
		// bZ[W
		m_filter.AddFilters("MSG ACK NAK");
	}
	if( m_bFiltering[FILTER_ETC] ){
		// ̑
		m_filter.AddFilters("URL NOT SND SDC FND PAG IPG");
	}
	if( m_bFiltering[FILTER_ERR] ){
		// G[
		m_filter.AddErrorFilter();
	}
	if( m_bFiltering[FILTER_CUSTOM] ){
		// JX^
		m_filter.AddFilters(m_custom.c_str());
	}
}

bool CComLogInfo::ShowFilterSettingDlg(HWND hWnd)
{
	CFilterSettingDlg dlg;

	Lock();
	dlg.SetMaxLog(m_logmax);
	dlg.SetFilter(m_bFiltering);
	dlg.SetEnableFilter(m_bEnableFilter);
	dlg.SetCustomString(m_custom.c_str());
	Unlock();

	if( dlg.DoModal(CNsmPlugin::GetModuleInstance(), hWnd) != IDOK )
		return false;

	Lock();
	m_logmax = dlg.GetMaxLog();
	m_bEnableFilter = dlg.GetEnableFilter();
	m_custom = dlg.GetCustomString();
	dlg.GetFilter(m_bFiltering);
	SetFilter();

	COMLOG_SETTING.SaveMaxLog(m_logmax);
	COMLOG_SETTING.SaveEnableFilter(m_bEnableFilter);
	COMLOG_SETTING.SaveFilters(m_bFiltering);
	COMLOG_SETTING.SaveCustomFilter(m_custom);
	Unlock();

	return true;
}
