#pragma once
#pragma warning( disable: 4702 )
	#include <vector>
	#include <map>
#pragma warning( default: 4702 )

#include "ConComLog.h"
#include "LogWindow.h"
#include "ComLogMan.h"

//*************************************************************************

//*************************************************************************

class CComLogMain
{
private:
	CComLogMan m_logManager;
	CRITICAL_SECTION m_lock;	// bNΏ: m_logManager

public:
	CComLogMain(void);
	~CComLogMain(void);

	void ShowLogWindow(HNsmConnection hConnection);
	void SetComLog(HNsmConnection hConnection, LPCTSTR header, LPCTSTR log);
	void CreateLog(HNsmConnection hConnection, LPCSTR proto, LPCSTR acc);
	void DeleteLog(HNsmConnection hConnection);
	void DeleteEntry(LPCSTR proto, LPCSTR acc);
	void AccUpdated(HNsmConnection hConnection, LPCSTR acc);
	void ShowOptionDialog(HWND hWnd);


protected:
	void Lock()
	{
		EnterCriticalSection(&m_lock);
	}
	void Unlock()
	{
		LeaveCriticalSection(&m_lock);
	}
};
