#include "StdAfx.h"
#include ".\comlogman.h"

CComLogMan::CComLogMan(void)
{
}

CComLogMan::~CComLogMan(void)
{
	AccMapping::iterator a;

	for( a = m_accMapping.begin();a != m_accMapping.end(); ++a )
	{
		delete a->second;
	}
}

//******************************************************************
// LogAndWnd
//******************************************************************

// hConnectioñO쐬ăXgɓo^
void CComLogMan::CreateNewEntry(HNsmConnection hConnection, LPCSTR proto, LPCSTR acc)
{
	CLogEntry* e;

	e = FindLogEntry(proto, acc);
	if( e == NULL )
	{
		e = new CLogEntry(proto, acc);
	}

	Regist(e);
	m_entries[hConnection] = e;
}

void CComLogMan::DeleteEntry(LPCSTR proto, LPCSTR acc)
{
	AccMapping::iterator a;
	std::string key;

	MakeAccMapKey(key, proto, acc);
	a = m_accMapping.find(key);
	if( a != m_accMapping.end() )
	{
		delete a->second;
		m_accMapping.erase(a);
	}
}

void CComLogMan::MarkEntryDeleted(HNsmConnection hCon)
{
	CLogEntry* e;

	e = FindLogEntry(hCon);
	if( e != NULL )
	{
		m_entries.erase(hCon);
		Unregist(e);
	}
}

// hConnectioñOEChE쐬ăXgɓo^B
CLogWindow* CComLogMan::CreateLogWindow(HNsmConnection hConnection)
{
	CLogWindow* wnd = NULL;
	CLogEntry* e;
_RPT1(_CRT_WARN, "CreateLogWindow(%d)\n", hConnection);

	e = FindLogEntry(hConnection);
	if( e != NULL )
	{
		wnd = e->CreateLogWindow();
	}

	return wnd;
}

void CComLogMan::AccUpdated(HNsmConnection hCon, LPCSTR acc)
{
	CLogEntry*  e;

	e = FindLogEntry(hCon);
	if( e != NULL )
	{
		e->UpdateAcc(acc);
	}
}

// Xgɓo^ĂSEChEXV
void CComLogMan::UpdateAllEntry()
{
	AccMapping::iterator a;

	for( a = m_accMapping.begin(); a != m_accMapping.end(); ++a )
	{
		CLogEntry* e = a->second;
		e->Update();
	}
}

//******************************************************************
// 
//******************************************************************
void CComLogMan::Regist(CLogEntry* e)
{
	std::string key;

	MakeAccMapKey(key, e->GetProtocol(), e->GetAccount());
	m_accMapping[key] = e;
	e->Regist();
}

void CComLogMan::Unregist(CLogEntry* e)
{
	e->Unregist();
	if( ! COMLOG_SETTING.IsKeepLogEnable() )
	{
		if( ! e->IsReferenced() )
		{
			e->MarkDeleted();
		}
	}
}
