#pragma once
#pragma warning( disable: 4702 )
	#include <map>
#pragma warning( default: 4702 )
#include "ConComLog.h"
#include "LogWindow.h"
#include "LogEntry.h"

class CComLogMan
{
protected:
	typedef std::map<HNsmConnection, CLogEntry*> LogEntryList;
	typedef std::map<std::string, CLogEntry*> AccMapping;

protected:
	AccMapping m_accMapping;
	LogEntryList m_entries;

public:
	CComLogMan(void);
	~CComLogMan(void);

public:
	void CreateNewEntry(HNsmConnection hConnection, LPCSTR proto, LPCSTR acc);
	CLogWindow* CreateLogWindow(HNsmConnection hConnection);
	void DeleteEntry(LPCSTR proto, LPCSTR acc);
	void MarkEntryDeleted(HNsmConnection hCon);
	void UpdateAllEntry();
	void AccUpdated(HNsmConnection hCon, LPCSTR acc);

	CLogWindow* FindLogWindow(HNsmConnection hConnection)
	{
		CLogEntry* e;

		e = FindLogEntry(hConnection);

		return (e != NULL) ? e->GetLogWindow(): NULL;
	}
	CConComLog* FindLogLines(HNsmConnection hConnection)
	{
		CLogEntry* e;

		e = FindLogEntry(hConnection);

		return (e != NULL) ? e->GetLogLines(): NULL;
	}

protected:
	void Regist(CLogEntry* e);
	void Unregist(CLogEntry* e);

	void MakeAccMapKey(std::string &key, LPCSTR proto, LPCSTR acc)
	{
		key = proto;
		key += "/";
		key += acc;
	}
	CLogEntry* FindLogEntry(LPCSTR proto, LPCSTR acc)
	{
		AccMapping::iterator a;
		std::string key;

		MakeAccMapKey(key, proto, acc);
		a = m_accMapping.find(key);
		return (a != m_accMapping.end()) ? a->second: NULL;
	}
	CLogEntry* FindLogEntry(HNsmConnection hCon)
	{
		LogEntryList::iterator i;
		i = m_entries.find(hCon);
		return (i != m_entries.end()) ? i->second: NULL;
	}
};
