#include "StdAfx.h"
#include <process.h>
#include ".\comlogplugin.h"
#include "..\nsmsgs\util.h"
#include "const.h"
#include "resource.h"
#include "NsmPlugin.h"
#include "mleak.h"


CComLogPlugin CComLogPlugin::m_singleton;
CComLogSettings CComLogSettings::m_singleton(PLUGIN_NAME);

//******************************************************************
// RXgN^EfXgN^
//******************************************************************

CComLogPlugin::CComLogPlugin(void)
{
	m_pApiVer		= NSM_API_VERSION;
	m_pModuleName	= NMM_ADDIN "/" PLUGIN_NAME;
	m_pTitle		= "ComLog";
	m_pDescription	= "Communication Log Viewer";
	m_pAuthor		= "fors";
	m_pCopyright	= "http://cc.ii2.cc/~fors/sysworks/prog/regne/";
	m_pPluginVer	= "0.3.0";

	m_hThread = INVALID_HANDLE_VALUE;
	::InitializeCriticalSection(&m_lock);
}

CComLogPlugin::~CComLogPlugin(void)
{
	::DeleteCriticalSection(&m_lock);
}

//******************************************************************
// W
//******************************************************************

int CComLogPlugin::OnInitialize()
{
	NSM_SERVICE.CreateService(CLP_SERVICE_SHOW_OPTION_DLG, ServiceShowOptionDialog);
	NSM_SERVICE.CreateService(CLP_SERVICE_UIMAIN_VIEW_LOG, ServiceViewLog);
	NSM_SERVICE.CreateService(CLP_SERVICE_UITAB_VIEW_LOG, ServiceViewLog);
	NSM_SERVICE.CreateService(CLP_SERVICE_DELETE_ENTRY, ServiceDeleteEntry);

	m_hThread = (HANDLE)_beginthreadex(NULL, 0, ComLogThread, this, 0, &m_threadID);
	return NMP_ALLRIGHT;
}

void CComLogPlugin::OnTerminate()
{
	if( m_hThread != INVALID_HANDLE_VALUE ){
		for(;;){
			if( ::PostThreadMessage(m_threadID, WM_QUIT, 0, 0) ) break;
			Sleep(10);
		}
		WaitForSingleObject(m_hThread, INFINITE);
		CloseHandle(m_hThread);
	}
}

int CComLogPlugin::OnSystemModulesLoaded()
{
	TCHAR buf[256];
	CCommonService::protocol_list plist;
	CCommonService::protocol_list::iterator i;

//	NSM_SERVICE.HookEvent(NME_SYSTEM_CONNECTION_CONNECT, HookConnect);
	NSM_SERVICE.HookEvent(NME_SYSTEM_CONNECTION_INFOCHANGE, HookInfoChange);
	NSM_SERVICE.HookEvent(NME_SYSTEM_CONNECTION_DISCONNECT, HookDisconnect);

	NSM_SERVICE.GetProtocolList(plist);
	for( i = plist.begin(); i != plist.end(); i++ )
	{
		_snprintf_s(buf, sizeof(buf), NME_PROTOCOL_LOG, i->c_str());
		NSM_SERVICE.HookEvent(buf, HookLog);
	}

	return NMP_ALLRIGHT;
}

int CComLogPlugin::DoShowOptionDialog(HWND hWnd)
{
	m_main.ShowOptionDialog(hWnd);

	return NMP_ALLRIGHT;
}

//******************************************************************
// CxgtbN
//******************************************************************
/*
int CComLogPlugin::OnConnect(HNsmConnection hConnection)
{
	LogOperateInfo loi;
	char proto[256];
	char acc[256];

	NSM_SERVICE.GetProtocol(hConnection, proto, sizeof(proto));
	NSM_SERVICE.GetUserAccount(hConnection, acc, sizeof(acc));

	loi.operation	= LO_CREATE;
	loi.hConnection	= hConnection;
	loi.header		= proto;
	loi.body		= acc;
	
	SendOperation(loi);

	return NMP_ALLRIGHT;
}
*/
/*
int CComLogPlugin::OnInfoChange(HNsmConnection hConnection, PNsmConnectionInfo pnci)
{
	if( pnci->nInfoKey == NMCI_USER_ACCOUNT )
	{
		LogOperateInfo loi;
		char acc[256];

		NSM_SERVICE.GetUserAccount(hConnection, acc, sizeof(acc));
	
		loi.operation	= LO_ACCUPDATED;
		loi.hConnection	= hConnection;
		loi.body		= acc;
		
		SendOperation(loi);
	}

	return NMP_ALLRIGHT;
}
*/
int CComLogPlugin::OnInfoChange(HNsmConnection hConnection, PNsmConnectionInfo pnci)
{
	if( pnci->nInfoKey == NMCI_USER_ACCOUNT )
	{
		LogOperateInfo loi;
		char proto[256];
		char acc[256];

		NSM_SERVICE.GetProtocol(hConnection, proto, sizeof(proto));
		NSM_SERVICE.GetUserAccount(hConnection, acc, sizeof(acc));

		loi.operation	= LO_CREATE;
		loi.hConnection	= hConnection;
		loi.header		= proto;
		loi.body		= acc;
		
		SendOperation(loi);
	}

	return NMP_ALLRIGHT;
}

int CComLogPlugin::OnDisconnect(HNsmConnection hConnection)
{
	LogOperateInfo loi;

	loi.operation	= LO_DELETE;
	loi.hConnection	= hConnection;

	SendOperation(loi);

	return NMP_ALLRIGHT;
}

int CComLogPlugin::OnLog(PNsmComLogInfo pmli)
{
//	char buf[16];
	HNsmConnection hConnection;
	LogOperateInfo loi;

	if( pmli->lpHandle == 0 ){
_RPT1(_CRT_WARN, "OnLog(%d)\n", pmli->lpHandle);
_RPT0(_CRT_WARN, pmli->lpMessage);
		return 0;
	}

	switch(pmli->nType){
	case NMHT_SESSION:
		hConnection = NSM_SERVICE.GetConnectionFromSession(pmli->lpHandle);
_RPT2(_CRT_WARN, "OnLog(%d =Ses=> %d)\n", pmli->lpHandle, hConnection);
		break;
	case NMHT_FILESESSION:
		hConnection = NSM_SERVICE.GetConnectionFromFileSession(pmli->lpHandle);
_RPT2(_CRT_WARN, "OnLog(%d =FS=> %d)\n", pmli->lpHandle, hConnection);
		break;
	default:
		hConnection = pmli->lpHandle;
_RPT2(_CRT_WARN, "OnLog(%d =Con=> %d)\n", pmli->lpHandle, hConnection);
		break;
	}

	loi.operation	= LO_SET;
	loi.hConnection	= hConnection;
	loi.header		= pmli->lpHeader;
	loi.body		= pmli->lpMessage;

	SendOperation(loi);

	return NMP_ALLRIGHT;
}

//******************************************************************
// T[rX
//******************************************************************

int CComLogPlugin::DoViewLog(HNsmConnection hConnection, PNsmUIServiceInfo pUISInfo)
{
	switch( pUISInfo->nInfoKey ){
	case NMUI_GETCAPTION:
		wcsncpy_s(
			(wchar_t*)pUISInfo->lpInfo->lpBuffer,
			pUISInfo->lpInfo->nBufferSize/sizeof(wchar_t),
			CLP_UI_VIEW_LOG,
			pUISInfo->lpInfo->nBufferSize/sizeof(wchar_t)
		);
		pUISInfo->lpInfo->nType = NMIT_WIDESTRING;
		break;

	case NMUI_ONCLICK:
		if( hConnection != NULL )
		{
			LogOperateInfo loi;

			loi.operation	= LO_OPENWINDOW;
			loi.hConnection	= hConnection;

			SendOperation(loi);
		}
		break;
	}
	return 1;
}

int CComLogPlugin::DoDeleteEntry(LPCSTR proto, LPCSTR acc)
{
	LogOperateInfo loi;

	loi.operation	= LO_DELETEENTRY;
	loi.header		= proto;
	loi.body		= acc;

	SendOperation(loi);
	return 0;
}

//******************************************************************
// ʐMOXbh
//******************************************************************

void CComLogPlugin::SendOperation(const LogOperateInfo& loi)
{
	Lock();
	m_operation_queue.push(loi);
	Unlock();

	::PostThreadMessage(m_threadID, WM_USER_WORKTHREADMSG, 0, 0);
}

bool CComLogPlugin::RecvOperation(LogOperateInfo& loi)
{
	bool bEmpty;

	Lock();
	{
		bEmpty = m_operation_queue.empty();
		if( ! bEmpty )
		{
			loi = m_operation_queue.front();
			m_operation_queue.pop();
		}
	}
	Unlock();

	return ! bEmpty;
}

unsigned int __stdcall CComLogPlugin::ComLogThread(void* pThis)
{
	CComLogPlugin &rThis = *(CComLogPlugin*)pThis;
	CComLogMain &rMain = rThis.m_main;
	LogOperateInfo loi;
	MSG msg;
	HACCEL hAccel;
	HWND hParent;
	unsigned int ret;

	hAccel = ::LoadAccelerators(CNsmPlugin::GetModuleInstance(), MAKEINTRESOURCE(IDR_ACCELERATOR1));

	while ( ::GetMessage(&msg, NULL, 0, 0) > 0 )
    {
		hParent = ::GetParent(msg.hwnd);
		if( hParent != NULL )
		{
			if( ::TranslateAccelerator(hParent, hAccel, &msg) )
			{
				continue;
			}
		}

		if ( ::IsDialogMessage(msg.hwnd, &msg) )
		{
			continue;
		}

		if( msg.message == WM_USER_WORKTHREADMSG )
		{
			while( rThis.RecvOperation(loi) )
			{
				switch(loi.operation){
				case LO_SET:
					rMain.SetComLog(loi.hConnection, loi.header.c_str(), loi.body.c_str());
					break;
				case LO_CREATE:
					rMain.CreateLog(loi.hConnection, loi.header.c_str(), loi.body.c_str());
					break;
				case LO_DELETE:
					rMain.DeleteLog(loi.hConnection);
					break;
				case LO_OPENWINDOW:
					rMain.ShowLogWindow(loi.hConnection);
					break;
				case LO_DELETEENTRY:
					rMain.DeleteEntry(loi.header.c_str(), loi.body.c_str());
				case LO_ACCUPDATED:
					rMain.AccUpdated(loi.hConnection, loi.body.c_str());
					break;
				}
			}
		}else{
	        ::TranslateMessage(&msg);
	        ::DispatchMessage(&msg);
		}
    }
	ret = msg.wParam;

	return ret;
}


