#pragma once
#include "..\nsmsgs\nsmplugin.h"
#pragma warning( disable: 4702 )
	#include <list>
	#include <queue>
#pragma warning( default: 4702 )
#include "const.h"
#include "ComLogSettings.h"
#include "ComLogInfo.h"
#include "LogWindow.h"
#include "ComLogMain.h"
#include "LogOperateInfo.h"

//***********************************************************
class CComLogPlugin :
	public CNsmPlugin
{
// Singleton -->
private:
	static CComLogPlugin m_singleton;

private:
	CComLogPlugin(void);
public:
	~CComLogPlugin(void);

public:
	static CComLogPlugin& GetInstance()
	{
		return m_singleton;
	}
// <-- Singleton

	friend CLogWindow;

// T[rXƃCxgtbN`
public:
//	DEFINE_EVENTHOOK1(Connect, HNsmConnection);
	DEFINE_EVENTHOOK2(InfoChange, HNsmConnection, PNsmConnectionInfo);
	DEFINE_EVENTHOOK1(Disconnect, HNsmConnection);
	DEFINE_EVENTHOOK1(Log, PNsmComLogInfo);

	DEFINE_SERVICE2(ViewLog, HNsmConnection, PNsmUIServiceInfo);
	DEFINE_SERVICE1(ShowOptionDialog, HWND);
	DEFINE_SERVICE2(DeleteEntry, LPCSTR, LPCSTR);

protected:
//	int OnConnect(HNsmConnection hConnection);
	int OnInfoChange(HNsmConnection hConnection, PNsmConnectionInfo pnci);
	int OnDisconnect(HNsmConnection hConnection);
	int OnLog(PNsmComLogInfo pmli);
	int DoViewLog(HNsmConnection hConnection, PNsmUIServiceInfo pnuisi);
	int DoDeleteEntry(LPCSTR proto, LPCSTR acc);

// I[o[Ch
public:
	int OnInitialize();
	void OnTerminate();
	int OnSystemModulesLoaded();
	int DoShowOptionDialog(HWND hWnd);

// ̑
protected:
	typedef std::queue<LogOperateInfo> OperationList;

private:
	CComLogMain m_main;			// CIuWFNg
	HANDLE m_hThread;			// Xbhnh
	unsigned int m_threadID;	// Xbhʎq
	OperationList m_operation_queue;	// XbhR}hL[
	CRITICAL_SECTION m_lock;	// R}hL[bNp

private:
	void SendOperation(const LogOperateInfo& loi);
	bool RecvOperation(LogOperateInfo& loi);
	void Lock()
	{
		::EnterCriticalSection(&m_lock);
	}
	void Unlock()
	{
		::LeaveCriticalSection(&m_lock);
	}

protected:
	void ShowFilterSettingDlg(HWND hWnd);

// ʐMOXbh
	static unsigned int __stdcall ComLogThread(void* pThis);
};
