#pragma once
#pragma warning( disable: 4702 )
	#include <list>
#pragma warning( default: 4702 )
#include <string>
#include "LogLine.h"
#include "Lock.h"
#include "DynamicArray.h"

class CConComLog
{
public:
	typedef std::list<CLogLine*> LogLineList;
	typedef CLock<CConComLog, LogLineList> LogLock;
	friend LogLock;

private:
	LogLineList m_lines;
	CRITICAL_SECTION m_lock;
	int m_nMultiLineLen;
	unsigned int m_log_st;
	std::string m_file;
	const std::string* const m_pProto;
	const std::string* const m_pAcc;
	const bool m_bMsnp8;

public:
	CConComLog(const std::string* proto, const std::string* acc);
	~CConComLog(void);
	const CConComLog& operator =(const CConComLog&)
	{ _ASSERT(FALSE); }

	// OnLog1񕪂̃O󂯎A_sƂAddLogɓn
	void SetComLog(char header, LPCSTR log);
	void Truncate(int max);
	void UpdateFilePath();

	bool IsMsnp8() const
	{ return m_bMsnp8; }

	unsigned int GetLogStartNo(void)
	{
		return m_log_st;
	}
	unsigned int GetLogEndNo(void) const
	{
		return m_log_st + m_lines.size() - 1;
	}
	void UpdateAcc()
	{
		UpdateFilePath();
	}

private:
	LogLineList& Lock()
	{
		EnterCriticalSection(&m_lock);
		return m_lines;
	}
	void Unlock()
	{
		LeaveCriticalSection(&m_lock);
	}

	// _s󂯎胍OXgɒǉB
	void AddLine(bool bFirstLine, char header, LPCSTR log, int len);
	int GetMultiLineLen(LPCTSTR line);
};

//**************************************************************

