#pragma once
#include <algorithm>
#pragma warning( disable: 4702 )
	#include <vector>
#pragma warning( default: 4702 )
#include "const.h"

#define MSN_COMMAND_LEN	3

typedef std::vector<unsigned int> FilterList;


class CFilter
{
private:
	FilterList m_list;
	bool m_bErrorFiltering;

public:
	CFilter()
	{
		m_bErrorFiltering = false;
	}
	~CFilter()
	{
		ClearFilter();
	}
	bool IsFiltering(LPCTSTR cmd)
	{
		return IsInList(cmd) || (m_bErrorFiltering && IsErrorCode(cmd));
	}
	void AddFilters(LPCTSTR str)
	{
		LPCTSTR pos;

		pos = str - 1;
		while( pos != NULL ){
			pos++;
			m_list.push_back(MakeKey(pos));
			pos = strchr(pos, ' ');
		}
		std::stable_sort(m_list.begin(), m_list.end());
	}
	void ClearFilter()
	{
		m_list.clear();
		m_bErrorFiltering = false;
	}
	void AddErrorFilter()
	{
		m_bErrorFiltering = true;
	}

private:
	bool IsErrorCode(LPCTSTR str)
	{
		return isdigit(*str++) && isdigit(*str++) && isdigit(*str++);
	}
	bool IsInList(LPCTSTR str)
	{
		return std::binary_search(m_list.begin(), m_list.end(), MakeKey(str));
	}
	unsigned int MakeKey(LPCTSTR str)
	{
		unsigned int key = 0;
		char *pkey = (char*)&key;

		for( int i = 0; i < MSN_COMMAND_LEN; i++ ){
			if( *str == '\0' ) break;
			*pkey++ = *str++;
		}
		return key;
	}
};
