#pragma once
#include <string>
#include "dlg.h"
#include "const.h"

//*************************************************************

class CFilterSettingDlg :
	public CDlg
{
private:
	bool m_bEnableFilter;
	bool m_bFiltering[FILTER_TYPE_NUM];
	bool m_bKeepLog;
	bool m_bRecLog;
	std::string m_custom;
	std::string m_logdir;
	int m_logmax;


public:
	CFilterSettingDlg(void);
	~CFilterSettingDlg(void);

// I[o[Ch
public:
	BOOL DlgProc(UINT uMsg, WPARAM wParam, LPARAM lParam);

private:
	BOOL InitDlgCtrl();
	BOOL GetDlgCtrlValue();
	void EnableAll(BOOL bEnable);

// ̑
public:
	void SetKeepLog(bool bKeep)
	{
		m_bKeepLog = bKeep;
	}
	bool GetKeepLog() const
	{
		return m_bKeepLog;
	}
	void SetRecLog(bool bRec)
	{
		m_bRecLog = bRec;
	}
	bool GetRecLog() const
	{
		return m_bRecLog;
	}
	void SetLogDir(LPCSTR logdir)
	{
		m_logdir = logdir;
	}
	LPCSTR GetLogDir() const
	{
		return m_logdir.c_str();
	}
	void SetMaxLog(int value)
	{
		m_logmax = value;
	}
	int GetMaxLog()
	{
		return m_logmax;
	}
	void SetEnableFilter(bool bEnable)
	{
		m_bEnableFilter = bEnable;
	}
	bool GetEnableFilter()
	{
		return m_bEnableFilter;
	}
	void SetFilter(const bool filter[])
	{
		for( int i = 0; i < FILTER_TYPE_NUM; i++ )
			m_bFiltering[i] = filter[i];
	}
	void GetFilter(bool bFilter[]) const
	{
		for( int i = 0; i < FILTER_TYPE_NUM; i++ ){
			bFilter[i] = m_bFiltering[i];
		}
	}
	void SetCustomString(LPCTSTR str)
	{
		m_custom = str;
	}
	LPCTSTR GetCustomString() const
	{
		return m_custom.c_str();
	}

private:
	void OnClickUseFilter();
	void OnClickFilterCustom();
	void OnClickRecLog();
	void OnClickLogDirRef();
	void UpdateLogDirEnable();

private:
	static int CALLBACK BrowsDlgProc(HWND hWnd, UINT uMsg, LPARAM lParam, LPARAM lpData);
};
