#include "StdAfx.h"
#include ".\logentry.h"
#include "NsmPlugin.h"

CLogEntry::CLogEntry(LPCSTR proto, LPCSTR acc)
: m_proto(proto)
, m_acc(acc)
, m_pLogWindow(NULL)
, m_lines(&m_proto, &m_acc)
, m_ref(0)
{
}

CLogEntry::~CLogEntry(void)
{
	delete m_pLogWindow;
}

CLogWindow* CLogEntry::CreateLogWindow()
{
	if( m_pLogWindow == NULL )
	{
		m_pLogWindow = new CLogWindow(&m_proto, &m_acc, &m_lines);
		m_pLogWindow->Create(CNsmPlugin::GetModuleInstance());
	}

	return m_pLogWindow;
}

void CLogEntry::Update()
{
	m_lines.UpdateFilePath();

	if( m_pLogWindow != NULL )
	{
		m_pLogWindow->UpdateFilter();
		if( COMLOG_SETTING.IsKeepLogEnable() )
		{
			m_pLogWindow->UnmarkDeleted();
		}
	}
}
