#pragma once
#include <string>
#include "LogWindow.h"
#include "ConComLog.h"

class CLogEntry
{
protected:
	const std::string m_proto;
	std::string m_acc;
	CLogWindow* m_pLogWindow;
	CConComLog m_lines;
	int m_ref;

public:
	CLogEntry(LPCSTR proto, LPCSTR acc);
	~CLogEntry(void);

	CLogWindow* CreateLogWindow();
	void Update();

	CLogWindow* GetLogWindow()
	{
		return m_pLogWindow;
	}
	CConComLog* GetLogLines()
	{
		return &m_lines;
	}
	void Regist()
	{
		_ASSERT( m_ref >= 0 );
		m_ref++;
		if( m_pLogWindow != NULL )
		{
			m_pLogWindow->UnmarkDeleted();
		}
	}
	void Unregist()
	{
		_ASSERT( m_ref > 0 );
		m_ref--;
	}
	bool IsReferenced()
	{
		return m_ref > 0;
	}
	LPCSTR GetProtocol() const
	{
		return m_proto.c_str();
	}
	LPCSTR GetAccount() const
	{
		return m_acc.c_str();
	}
	void MarkDeleted()
	{
		if( m_pLogWindow != NULL )
		{
			m_pLogWindow->MarkDeleted();
		}
	}
	void UpdateAcc(LPCSTR acc)
	{
		m_acc = acc;
		m_lines.UpdateAcc();
		if( m_pLogWindow != NULL )
		{
			m_pLogWindow->UpdateAcc();
		}
	}

private:
	const CLogEntry& operator =(CLogEntry&)
	{}
};
