#pragma once
#include <string>
#include "CommonService.h"

class CLogLine
{
private:
	char m_sender[2];
	char m_time[9];
	std::string m_msg;
	bool m_bFirstLine;
	int m_no;

public:
	CLogLine()
	{
		m_sender[0] = '\0';
		m_time[0] = '\0';
		m_bFirstLine = true;
		m_no = -1;
	}
	void Set(LPCSTR timestamp, char header, LPCTSTR str, bool bFirstLine, int no)
	{
		if( bFirstLine )
		{
			m_sender[0] = header;
			m_sender[1] = '\0';

			strncpy_s(m_time, 8, timestamp, 8);
			m_time[8] = '\0';
		}

		m_msg = str;
		m_no = no;
		m_bFirstLine = bFirstLine;
	}
	bool IsFirstLine() const
	{
		return m_bFirstLine;
	}
	~CLogLine(void)
	{
	}
	int GetNo() const
	{
		return m_no;
	}
	LPCSTR GetSender() const
	{
		return m_sender;
	}
	LPCTSTR GetTime() const
	{
		return m_time;
	}
	LPCTSTR GetMsg() const
	{
		return m_msg.c_str();
	}
	std::string GetFormattedLine()
	{
		std::string str;

		if( strcmp(m_sender, "") != 0 ){
			str += m_time;
			str += "\t";
			str += m_sender;
			str += "\t";
		}

		str += m_msg;
		str += "\r\n";

		return str;
	}

};
